#ifndef KEM_API_H
#define KEM_API_H

#include "params.h"

#define KEM_SECRETKEYBYTES N_BYTES
#define KEM _PUBLICKEYBYTES N_BYTES
#define KEM _BYTES 3*N_BYTES
#define KEM _CIPHERTEXTBYTES N_BYTES
#define KEM _ALGNAME COLA_KEM

int kem_keygen( unsigned char *pk, unsigned char *sk);
int kem_enc(unsigned char *pk,unsigned char *ss, unsigned char *ct);
int kem_dec(unsigned char *sk,unsigned char *ct, unsigned char *ss);

#endif