//just for practice

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "poly.h"
#include "params.h"
#include "kem.h"
#include "pke.h"
#include "byte.h"


int main()
{	
	FILE *fp,*fpt;
	clock_t start,finish;
	double total_time;
	int m[2*N]={0},m1[N]={0},m2[N]={0},i;
	unsigned char ss1[N_BYTES],ss2[N_BYTES],b[2*N_BYTES],b1[N_BYTES],b2[N_BYTES],pk[N_BYTES],sk[N_BYTES],ct[N_BYTES],m0[N_BYTES],pk1[N_BYTES],sk1[N_BYTES],c_pke[2*N_BYTES];
	unsigned long long clen[1],mlen[1];
	srand((unsigned int)time(NULL));
	start=clock();
	kem_keygen(pk,sk);
	total_time=(double)(finish-start)/CLOCKS_PER_SEC;
    printf("key generate time:%f us\n",(total_time*1000000));
	start=clock();
	kem_enc(pk,ss1,ct);
	printf("key generate time:%f us\n",(total_time*1000000));
	start=clock();
	kem_dec(sk,pk,ct,ss2);
	printf("key generate time:%f us\n",(total_time*1000000));
	randpoly3(m);
	start=clock();
	pke_keygen(pk1,sk1);
	printf("key generate time:%f us\n",(total_time*1000000));
	fp=fopen("cola_kem","w+");
	fprintf(fp,"\nPUBLICKEY:\n");
	for(i=0;i<N_BYTES;i++) fprintf(fp,"%d,",pk[i]);
	fprintf(fp,"\nSECRETKEY:\n");
	for(i=0;i<N_BYTES;i++) fprintf(fp,"%d,",sk[i]);
	fprintf(fp,"\nCIPHERTEXT:\n");
	for(i=0;i<N_BYTES;i++) fprintf(fp,"%d,",ct[i]);
	fprintf(fp,"\nSHAREDKEY:\n");
	for(i=0;i<N_BYTES;i++) fprintf(fp,"%d,",ss1[i]);
	poly_tobytes(m0,m);
	start=clock();
	pke_enc(pk1,m0,N_BYTES,c_pke,clen);
	printf("key generate time:%f us\n",(total_time*1000000));
	pke_dec(sk1,c_pke,2*N_BYTES,m0,mlen);
	start=clock();
	printf("key generate time:%f us\n",(total_time*1000000));
	fpt=fopen("cola_pke","w+");
	fprintf(fp,"\nPUBLICKEY:\n");
	for(i=0;i<N_BYTES;i++) fprintf(fp,"%d,",pk1[i]);
	fprintf(fp,"\nSECRETKEY:\n");
	for(i=0;i<N_BYTES;i++) fprintf(fp,"%d,",sk1[i]);
	fprintf(fp,"\nCIPHERTEXT:\n");
	for(i=0;i<2*N_BYTES;i++) fprintf(fp,"%d,",c_pke[i]);
	fprintf(fp,"\nSHAREDKEY:\n");
	for(i=0;i<N_BYTES;i++) fprintf(fp,"%d,",m0[i]);
	return 0;
}

