#ifndef POLY_H
#define POLY_H

#include <stdio.h>
#include <stdlib.h>
#include "params.h"

void display(int *f,int n);
void init(int *f);
void randpoly1(int *f);
void randpoly2(int *f);
void randpoly3(int *f);
void add_poly(int *f,int *g,int *h,int q);
void sub_poly(int *f,int *g,int *h,int q);
void dsum_poly(int *f,int *g,int *h);
void eval_poly(int *f,int *g);
void circulmat(int *f,int *F);
void multi_poly(int *f,int *g,int *h,int q);
int inv_num(int n,int q);
int deg(int *f);
void preprem_poly(int *f,int *g,int *p,int *lc,int q);
void prem_poly(int *fc,int *g,int *p,int *r,int *lc,int q);
void inv_poly_mod2(int *f,int *f2);
void inv_poly(int *f,int *fq);

#endif